Index: editor/frontend/src/main/java/org/hippoecm/frontend/editor/workflow/DefaultWorkflowPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- editor/frontend/src/main/java/org/hippoecm/frontend/editor/workflow/DefaultWorkflowPlugin.java	(revision 48312)
+++ editor/frontend/src/main/java/org/hippoecm/frontend/editor/workflow/DefaultWorkflowPlugin.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2008-2014 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2008-2015 Hippo B.V. (http://www.onehippo.com)
  * 
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -68,8 +68,10 @@
 import org.hippoecm.frontend.service.render.RenderPlugin;
 import org.hippoecm.frontend.session.UserSession;
 import org.hippoecm.frontend.skin.Icon;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.repository.api.Document;
 import org.hippoecm.repository.api.HippoNode;
+import org.hippoecm.repository.api.HippoNodeType;
 import org.hippoecm.repository.api.Localized;
 import org.hippoecm.repository.api.StringCodec;
 import org.hippoecm.repository.api.StringCodecFactory;
@@ -189,11 +191,11 @@
 
             @Override
             protected String execute(Workflow wf) throws Exception {
-                if (targetName == null || targetName.trim().equals("")) {
+                if (Strings.isEmpty(targetName)) {
                     throw new WorkflowException("No name for destination given");
                 }
                 HippoNode node = (HippoNode) getModel().getNode();
-                String nodeName = getNodeNameCodec().encode(uriName);
+                String nodeName = getNodeNameCodec(node).encode(uriName);
                 String localName = getLocalizeCodec().encode(targetName);
                 if ("".equals(nodeName)) {
                     throw new IllegalArgumentException("You need to enter a name");
@@ -211,7 +213,7 @@
         });
 
         add(copyAction = new StdWorkflow("copy", new StringResourceModel("copy-label", this, null), context, getModel()) {
-            NodeModelWrapper destination = null;
+            NodeModelWrapper<Node> destination = null;
             String name = null;
 
             @Override
@@ -226,7 +228,7 @@
 
             @Override
             protected Dialog createRequestDialog() {
-                destination = new NodeModelWrapper(getFolder()) {
+                destination = new NodeModelWrapper<Node>(getFolder()) {
                 };
                 try {
                     HippoNode node = (HippoNode) getModel().getNode();
@@ -235,9 +237,12 @@
                     if (isExtension(nodeName, KNOWN_IMAGE_EXTENSIONS)) {
                         createNewNodeNameForImage(nodeName);
                     } else {
+                        String locale = CodecUtils.getLocaleFromNode(getFolder().getNode());
+                        IModel<StringCodec> codec = CodecUtils.getNodeNameCodecModel(context, locale);
                         String copyof = new StringResourceModel("copyof", DefaultWorkflowPlugin.this, null).getString();
-                        CopyNameHelper copyNameHelper = new CopyNameHelper(getNodeNameCodec(), copyof);
-                        name = copyNameHelper.getCopyName(nodeName, destination.getNodeModel().getNode());
+                        CopyNameHelper copyNameHelper = new CopyNameHelper(codec, copyof);
+
+                        name = copyNameHelper.getCopyName(nodeName, destination.getChainedModel().getObject());
                     }
                 } catch (RepositoryException ex) {
                     return new ExceptionDialog(ex);
@@ -245,7 +250,7 @@
                 return new DestinationDialog(
                         new StringResourceModel("copy-title", DefaultWorkflowPlugin.this, null),
                         new StringResourceModel("copy-name", DefaultWorkflowPlugin.this, null),
-                        new PropertyModel(this, "name"), destination, context, config) {
+                        new PropertyModel<String>(this, "name"), destination, context, config) {
                     {
                         setOkEnabled(true);
                     }
@@ -267,7 +272,7 @@
              */
             private void createNewNodeNameForImage(final String nodeName) throws RepositoryException {
                 name = nodeName;
-                Node gallery = destination.getNodeModel().getNode();
+                Node gallery = destination.getChainedModel().getObject();
                 if (gallery.hasNode(name)) {
                     name = addOrIncrementNodeNameSuffixForImage(name);
                     createNewNodeNameForImage(name);
@@ -306,31 +311,32 @@
 
             @Override
             protected String execute(Workflow wf) throws Exception {
-                JcrNodeModel folderModel = new JcrNodeModel("/");
-                if (destination != null) {
-                    folderModel = destination.getNodeModel();
-                }
-                StringCodec codec = getNodeNameCodec();
+                final Node folder = destination != null ?
+                        destination.getChainedModel().getObject() : UserSession.get().getJcrSession().getRootNode();
+
+                final String locale = CodecUtils.getLocaleFromDocumentOrFolder(getModel().getNode(), folder);
+                final StringCodec codec = CodecUtils.getNodeNameCodec(getPluginContext(), locale);
                 String nodeName = codec.encode(name);
 
                 DefaultWorkflow workflow = (DefaultWorkflow) wf;
-                workflow.copy(new Document(folderModel.getNode()), nodeName);
-                JcrNodeModel copyMode = new JcrNodeModel(folderModel.getItemModel().getPath() + "/" + nodeName);
-                HippoNode node = (HippoNode) copyMode.getNode().getNode(nodeName);
+                workflow.copy(new Document(folder), nodeName);
 
+                JcrNodeModel copyModel = new JcrNodeModel(folder.getPath() + "/" + nodeName);
+                HippoNode node = (HippoNode) copyModel.getNode().getNode(nodeName);
+
                 String localName = getLocalizeCodec().encode(name);
                 if (!node.getLocalizedName().equals(localName)) {
                     WorkflowManager manager = UserSession.get().getWorkflowManager();
                     DefaultWorkflow defaultWorkflow = (DefaultWorkflow) manager.getWorkflow("core", node);
                     defaultWorkflow.localizeName(localName);
                 }
-                browseTo(copyMode);
+                browseTo(copyModel);
                 return null;
             }
         });
 
         add(moveAction = new StdWorkflow("move", new StringResourceModel("move-label", this, null), context, getModel()) {
-            public NodeModelWrapper destination = null;
+            public NodeModelWrapper<Node> destination = null;
 
             @Override
             public String getSubMenu() {
@@ -344,7 +350,7 @@
 
             @Override
             protected Dialog createRequestDialog() {
-                destination = new NodeModelWrapper(getFolder()) {
+                destination = new NodeModelWrapper<Node>(getFolder()) {
                 };
                 return new DestinationDialog(new StringResourceModel("move-title",
                         DefaultWorkflowPlugin.this, null), null, null, destination, context, config) {
@@ -357,15 +363,54 @@
 
             @Override
             protected String execute(Workflow wf) throws Exception {
-                JcrNodeModel folderModel = new JcrNodeModel("/");
-                if (destination != null) {
-                    folderModel = destination.getNodeModel();
+
+                final Node src = getModel().getNode();
+                final Node dest = destination != null ?
+                        destination.getChainedModel().getObject() : UserSession.get().getJcrSession().getRootNode();
+
+                final String srcLocale = CodecUtils.getLocaleFromNodeAndAncestors(src);
+                final String destLocale = CodecUtils.getLocaleFromNodeAndAncestors(dest);
+
+                StringCodec codec = null;
+                if (srcLocale == null) {
+                    if (destLocale != null) {
+                        codec = CodecUtils.getNodeNameCodec(getPluginContext(), destLocale);
                 }
-                String nodeName = getModel().getNode().getName();
+                } else if (!srcLocale.equals(destLocale)) {
+                    codec = CodecUtils.getNodeNameCodec(getPluginContext(), destLocale);
+                }
+
+                String nodeName;
+                if (codec != null) {
+                    // we are moving between locales so re-encode the display name
+                    nodeName = codec.encode(getDisplayOrNodeName(src));
+                } else {
+                    // use original node name
+                    nodeName = src.getName();
+                }
+
                 DefaultWorkflow workflow = (DefaultWorkflow) wf;
-                workflow.move(new Document(folderModel.getNode()), nodeName);
+                workflow.move(new Document(dest), nodeName);
                 return null;
             }
+
+            private String getDisplayOrNodeName(final Node node) throws RepositoryException {
+                Node handle = node;
+                if (!node.isNodeType(HippoNodeType.NT_HANDLE)) {
+                    Node parent = node.getParent();
+                    if (parent != null && parent.isNodeType(HippoNodeType.NT_HANDLE)) {
+                        handle = parent;
+                    }
+                }
+
+                if (handle.isNodeType(HippoNodeType.NT_TRANSLATED) && handle.hasNode(HippoNodeType.NT_TRANSLATION)) {
+                    // use the first translation node message
+                    Node translationNode = handle.getNode(HippoNodeType.NT_TRANSLATION);
+                    return translationNode.getProperty(HippoNodeType.HIPPO_MESSAGE).getString();
+                } else {
+                    return node.getName();
+                }
+            }
         });
 
         add(deleteAction = new StdWorkflow("delete",
@@ -458,24 +503,19 @@
     }
 
     protected StringCodec getLocalizeCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.display");
+        return CodecUtils.getDisplayNameCodec(getPluginContext());
     }
 
-    protected StringCodec getNodeNameCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.node");
+    protected StringCodec getNodeNameCodec(final Node node) {
+        return CodecUtils.getNodeNameCodec(getPluginContext(), node);
     }
 
     private void browseTo(JcrNodeModel nodeModel) throws RepositoryException {
         //refresh session before IBrowseService.browse is called
         obtainUserSession().getJcrSession().refresh(false);
 
-        IBrowseService service = getPluginContext().getService(getPluginConfig().getString(IBrowseService.BROWSER_ID),
+        @SuppressWarnings("unchecked")
+        IBrowseService<IModel<Node>> service = getPluginContext().getService(getPluginConfig().getString(IBrowseService.BROWSER_ID),
                 IBrowseService.class);
         if (service != null) {
             service.browse(nodeModel);
@@ -489,7 +529,7 @@
             return (new NodeTranslator(new JcrNodeModel(getModel().getNode()))).getNodeName();
         } catch (RepositoryException ex) {
             try {
-                return new Model<String>(getModel().getNode().getName());
+                return new Model<>(getModel().getNode().getName());
             } catch (RepositoryException e) {
                 return new StringResourceModel("unknown", this, null);
             }
@@ -513,12 +553,8 @@
                 Workflow workflow = manager.getWorkflow(workflowDescriptor);
                 info = workflow.hints();
             }
-        } catch (RepositoryException ex) {
+        } catch (RepositoryException | WorkflowException | RemoteException ex) {
             log.error(ex.getMessage());
-        } catch (RemoteException e) {
-            log.error(e.getMessage());
-        } catch (WorkflowException e) {
-            log.error(e.getMessage());
         }
         return info;
     }
@@ -536,31 +572,41 @@
         whereUsedAction.setVisible(!Boolean.FALSE.equals(workflowHints.get("status")));
     }
 
-    public class RenameDocumentDialog extends AbstractWorkflowDialog {
-        private IModel title;
+    public class RenameDocumentDialog extends AbstractWorkflowDialog<WorkflowDescriptor> {
+        private IModel<String> title;
         private TextField nameComponent;
         private TextField uriComponent;
         private boolean uriModified;
 
-        public RenameDocumentDialog(StdWorkflow action, IModel title) {
+        public RenameDocumentDialog(StdWorkflow action, IModel<String> title) {
             super(DefaultWorkflowPlugin.this.getModel(), action);
             this.title = title;
 
-            final PropertyModel<String> nameModel = new PropertyModel<String>(action, "targetName");
-            final PropertyModel<String> uriModel = new PropertyModel<String>(action, "uriName");
+            String locale = null;
+            try {
+                locale = CodecUtils.getLocaleFromNodeAndAncestors(DefaultWorkflowPlugin.this.getModel().getNode());
+            } catch (RepositoryException e) {
+                //ignore
+            }
 
+            final IModel<StringCodec> codecModel = CodecUtils.getNodeNameCodecModel(getPluginContext(), locale);
+
+            final PropertyModel<String> nameModel = new PropertyModel<>(action, "targetName");
+            final PropertyModel<String> uriModel = new PropertyModel<>(action, "uriName");
+
             String s1 = nameModel.getObject();
             String s2 = uriModel.getObject();
             uriModified = !s1.equals(s2);
 
-            nameComponent = new TextField<String>("name", nameModel);
+            nameComponent = new TextField<>("name", nameModel);
             nameComponent.setRequired(true);
             nameComponent.setLabel(new StringResourceModel("name-label", DefaultWorkflowPlugin.this, null));
             nameComponent.add(new OnChangeAjaxBehavior() {
                 @Override
                 protected void onUpdate(AjaxRequestTarget target) {
                     if (!uriModified) {
-                        uriModel.setObject(getNodeNameCodec().encode(nameModel.getObject()));
+                        String uri = codecModel.getObject().encode(nameModel.getObject());
+                        uriModel.setObject(uri);
                         target.add(uriComponent);
                     }
                 }
@@ -595,8 +641,10 @@
                 public void onClick(AjaxRequestTarget target) {
                     uriModified = !uriModified;
                     if (!uriModified) {
-                        uriModel.setObject(Strings.isEmpty(nameModel.getObject()) ? "" : getNodeNameCodec().encode(
-                                nameModel.getObject()));
+                        StringCodec codec = codecModel.getObject();
+                        String uri = Strings.isEmpty(nameModel.getObject()) ? "" : codec.encode(nameModel.getObject());
+                        uriModel.setObject(uri);
+                        uriComponent.modelChanged();
                     } else {
                         target.focusComponent(uriComponent);
                     }
Index: builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/FolderShortcutPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/FolderShortcutPlugin.java	(revision 48312)
+++ builtin/src/main/java/org/hippoecm/frontend/plugins/standardworkflow/FolderShortcutPlugin.java	(revision )
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2008-2013 Hippo B.V. (http://www.onehippo.com)
+ *  Copyright 2008-2015 Hippo B.V. (http://www.onehippo.com)
  * 
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -56,17 +56,16 @@
 import org.hippoecm.frontend.service.IBrowseService;
 import org.hippoecm.frontend.service.IEditor;
 import org.hippoecm.frontend.service.IEditorManager;
-import org.hippoecm.frontend.service.ISettingsService;
 import org.hippoecm.frontend.service.ServiceException;
 import org.hippoecm.frontend.service.render.RenderPlugin;
 import org.hippoecm.frontend.session.UserSession;
 import org.hippoecm.frontend.translation.ILocaleProvider;
+import org.hippoecm.frontend.util.CodecUtils;
 import org.hippoecm.repository.api.Document;
 import org.hippoecm.repository.api.HippoNodeType;
 import org.hippoecm.repository.api.HippoWorkspace;
 import org.hippoecm.repository.api.MappingException;
 import org.hippoecm.repository.api.StringCodec;
-import org.hippoecm.repository.api.StringCodecFactory;
 import org.hippoecm.repository.api.Workflow;
 import org.hippoecm.repository.api.WorkflowDescriptor;
 import org.hippoecm.repository.api.WorkflowException;
@@ -183,14 +182,8 @@
                                     editorMgr.openEditor(editNodeModel);
                                 }
                             }
-                        } catch (WorkflowException ex) {
+                        } catch (WorkflowException | ServiceException | RepositoryException | RemoteException ex) {
                             log.error("Cannot auto-edit document", ex);
-                        } catch (RemoteException ex) {
-                            log.error("Cannot auto-edit document", ex);
-                        } catch (RepositoryException ex) {
-                            log.error("Cannot auto-edit document", ex);
-                        } catch (ServiceException ex) {
-                            log.error("Cannot auto-edit document", ex);
                         }
                     }
                 }
@@ -201,26 +194,16 @@
     }
 
     protected StringCodec getLocalizeCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.display");
+        return CodecUtils.getDisplayNameCodec(getPluginContext());
     }
 
-    protected StringCodec getNodeNameCodec() {
-        ISettingsService settingsService = getPluginContext().getService(ISettingsService.SERVICE_ID,
-                ISettingsService.class);
-        StringCodecFactory stringCodecFactory = settingsService.getStringCodecFactory();
-        return stringCodecFactory.getStringCodec("encoding.node");
-    }
-
     protected ILocaleProvider getLocaleProvider() {
         return getPluginContext().getService(
                 getPluginConfig().getString(ILocaleProvider.SERVICE_ID, ILocaleProvider.class.getName()),
                 ILocaleProvider.class);
     }
 
-    public class Dialog extends AbstractDialog {
+    public class Dialog extends AbstractDialog<WorkflowDescriptor> {
         private static final long serialVersionUID = 1L;
 
         private String templateCategory = null;
@@ -231,8 +214,8 @@
         private final IServiceReference<IEditorManager> editServiceRef;
         private Map<String, Set<String>> templates;
 
-        private final DropDownChoice prototypeChoice;
-        private final DropDownChoice templateChoice;
+        private final DropDownChoice<String> prototypeChoice;
+        private final DropDownChoice<String> templateChoice;
 
         private String optionSelectOnly = null;
         private boolean optionSelectFirst = false;
@@ -268,7 +251,8 @@
                 folderWorkflowDescriptorModel = new WorkflowDescriptorModel(workflowCategory, folder);
                 Workflow workflow = folderWorkflowDescriptorModel.getWorkflow();
                 if (workflow instanceof FolderWorkflow) {
-                    templates = ((FolderWorkflow) workflow).list();
+                    FolderWorkflow folderWorkflow = (FolderWorkflow) workflow;
+                    templates = (Map<String, Set<String>>) folderWorkflow.hints().get("prototypes");
                 } else {
                     folder = null;
                     templates = Collections.emptyMap();
@@ -276,13 +260,13 @@
 
                 if (optionSelectFirst) {
                     if (optionSelectOnly != null) {
-                        Map<String, Set<String>> newTemplates = new TreeMap<String, Set<String>>();
+                        Map<String, Set<String>> newTemplates = new TreeMap<>();
                         if (templates.containsKey(optionSelectOnly)) {
                             newTemplates.put(optionSelectOnly, templates.get(optionSelectOnly));
                         }
                         templates = newTemplates;
                     } else {
-                        Map<String, Set<String>> newTemplates = new TreeMap<String, Set<String>>();
+                        Map<String, Set<String>> newTemplates = new TreeMap<>();
                         if (templates.size() > 0) {
                             Map.Entry<String, Set<String>> firstEntry = templates.entrySet().iterator().next();
                             newTemplates.put(firstEntry.getKey(), firstEntry.getValue());
@@ -290,7 +274,7 @@
                         templates = newTemplates;
                     }
                 } else if (optionSelectOnly != null) {
-                    Map<String, Set<String>> newTemplates = new TreeMap<String, Set<String>>();
+                    Map<String, Set<String>> newTemplates = new TreeMap<>();
                     if (templates.containsKey(optionSelectOnly)) {
                         newTemplates.put(optionSelectOnly, templates.get(optionSelectOnly));
                     }
@@ -310,22 +294,23 @@
                 folder = null;
             }
 
-            add(new Label("message", new Model("")));
+            add(new Label("message", Model.of("")));
 
-            add(nameUriContainer = new NameUriField("name-url", new LoadableDetachableModel<StringCodec>() {
-                private static final long serialVersionUID = 1L;
-
+            final IModel<StringCodec> codecModel = new LoadableDetachableModel<StringCodec>() {
                 @Override
                 protected StringCodec load() {
-                    return getNodeNameCodec();
+                    //language value can change between load() calls
+                    return CodecUtils.getNodeNameCodec(getPluginContext(), language);
                 }
-            }));
+            };
 
-            List<String> emptyList = new LinkedList<String>();
+            add(nameUriContainer = new NameUriField("name-url", codecModel));
+
+            List<String> emptyList = new LinkedList<>();
             emptyList.add("");
 
             prototypeContainer = new WebMarkupContainer("prototype");
-            prototypeContainer.add(prototypeChoice = new DropDownChoice("select", new PropertyModel(this, "prototype"),
+            prototypeContainer.add(prototypeChoice = new DropDownChoice<>("select", new PropertyModel<String>(this, "prototype"),
                     emptyList));
             prototypeChoice.add(new AjaxFormComponentUpdatingBehavior("onchange") {
                 private static final long serialVersionUID = 1L;
@@ -341,7 +326,7 @@
             add(prototypeContainer);
 
             templateContainer = new WebMarkupContainer("template");
-            templateContainer.add(templateChoice = new DropDownChoice<String>("select", new PropertyModel<String>(this,
+            templateContainer.add(templateChoice = new DropDownChoice<>("select", new PropertyModel<String>(this,
                     "templateCategory"), emptyList, new IChoiceRenderer<String>() {
                 private static final long serialVersionUID = 1L;
 
@@ -360,6 +345,10 @@
                 protected void onUpdate(AjaxRequestTarget target) {
                     prototype = null;
                     evaluateChoices();
+                    // Detach the codec model to load the correct codec for the selected template
+                    codecModel.detach();
+                    // Re-encode the URI value
+                    nameUriContainer.encodeUri();
                 }
             });
             templateChoice.setNullValid(false);
@@ -368,18 +357,21 @@
             templateContainer.add(new Label("typelabel", new StringResourceModel("document-type", this, null)));
             add(templateContainer);
 
-            languageContainer = new LanguageField("language", new PropertyModel<String>(this, "language"), getLocaleProvider());
+            languageContainer = new LanguageField("language", new PropertyModel<String>(this, "language"), getLocaleProvider()) {
+                @Override
+                protected void onSelectionChanged() {
+                    // Detach the codec model to load the correct codec for the selected language
+                    codecModel.detach();
+                    // Re-encode the URI value
+                    nameUriContainer.encodeUri();
+                }
+            };
             add(languageContainer);
 
-            setOkEnabled(false);
-
-            if (folder != null && folderWorkflowDescriptorModel != null) {
-                setModel(folderWorkflowDescriptorModel);
+            setModel(folderWorkflowDescriptorModel);
-                setOkEnabled(true);
-            } else {
-                setModel(null);
-            }
-            if (templates.keySet().size() >= 1) {
+            setOkEnabled(folder != null);
+
+            if (templates != null && templates.keySet().size() >= 1) {
                 // pre-select the first item in the template category
                 templateCategory = templates.keySet().iterator().next();
             }
@@ -387,18 +379,18 @@
         }
 
         private void evaluateChoices() {
-            if (templates.keySet().size() == 1) {
-                templateChoice.setChoices(new LinkedList<String>(templates.keySet()));
+            if (templates == null || templates.keySet().size() == 0) {
                 templateContainer.setVisible(false);
+            } else if (templates.keySet().size() == 1) {
+                templateChoice.setChoices(new LinkedList<>(templates.keySet()));
+                templateContainer.setVisible(false);
             } else if (templates.keySet().size() > 1) {
-                templateChoice.setChoices(new LinkedList<String>(templates.keySet()));
+                templateChoice.setChoices(new LinkedList<>(templates.keySet()));
                 templateContainer.setVisible(true);
-            } else {
-                templateContainer.setVisible(false);
             }
             boolean languageVisible = false;
             if (templateCategory != null) {
-                final List<String> prototypesList = new LinkedList<String>(templates.get(templateCategory));
+                final List<String> prototypesList = new LinkedList<>(templates.get(templateCategory));
                 prototypeChoice.setChoices(prototypesList);
                 prototypeChoice.setChoiceRenderer(new TypeChoiceRenderer(this));
                 if (prototypesList.size() > 1) {
@@ -444,9 +436,15 @@
                     target.add(this);
                 }
             }
+
+            // By resetting the language the URI is re-encoded using the correct StringCodec
+            // when switching between translated and non-translated root folders
+            if (!languageVisible) {
+                language = null;
         }
+     }
 
-        public IModel getTitle() {
+        public IModel<String> getTitle() {
             return new StringResourceModel("new-document-label", this, null);
         }
 
@@ -462,8 +460,8 @@
                 if (model != null && model instanceof WorkflowDescriptorModel) {
                     Session jcrSession = UserSession.get().getJcrSession();
                     WorkflowManager manager = ((HippoWorkspace) (jcrSession.getWorkspace())).getWorkflowManager();
-                    FolderWorkflow workflow = (FolderWorkflow) manager
-                            .getWorkflow((WorkflowDescriptor) ((WorkflowDescriptorModel) model).getObject());
+                    FolderWorkflow workflow = (FolderWorkflow) manager.getWorkflow(((WorkflowDescriptorModel) model)
+                            .getObject());
                     if (prototype == null) {
                         error("You need to select a type");
                         return;
@@ -476,9 +474,9 @@
                         }
 
                         String localName = getLocalizeCodec().encode(name);
-                        String nodeName = getNodeNameCodec().encode(url);
+                        String nodeName = CodecUtils.getNodeNameCodec(getPluginContext(), language).encode(url);
 
-                        TreeMap<String, String> arguments = new TreeMap<String, String>();
+                        TreeMap<String, String> arguments = new TreeMap<>();
                         arguments.put("name", nodeName);
                         if (language != null) {
                             arguments.put("hippotranslation:locale", language);
